/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (6.0.1).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package jetty.openapi.api;

import jetty.openapi.models.CredentialsDTO;
import jetty.openapi.models.JwtDTO;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import jakarta.validation.Valid;
import jakarta.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import jakarta.annotation.Generated;

@Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2023-07-12T16:08:09.013419200+01:00[Europe/London]")
@Validated
@Tag(name = "authenticate", description = "the authenticate API")
public interface AuthenticateApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    /**
     * POST /authenticate : returns a JWT auth token in response to a valid username/password
     *
     * @param credentialsDTO Credentials object containing username + password (required)
     * @return OK (status code 200)
     *         or Unauthorised (status code 401)
     */
    @Operation(
        operationId = "authenticatePost",
        summary = "returns a JWT auth token in response to a valid username/password",
        responses = {
            @ApiResponse(responseCode = "200", description = "OK", content = {
                @Content(mediaType = "application/json", schema = @Schema(implementation = JwtDTO.class))
            }),
            @ApiResponse(responseCode = "401", description = "Unauthorised")
        }
    )
    @RequestMapping(
        method = RequestMethod.POST,
        value = "/authenticate",
        produces = { "application/json" },
        consumes = { "application/json" }
    )
    default ResponseEntity<JwtDTO> authenticatePost(
        @Parameter(name = "CredentialsDTO", description = "Credentials object containing username + password", required = true) @Valid @RequestBody CredentialsDTO credentialsDTO
    ) {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "{ \"token\" : \"token\" }";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
